SHADER version 1
@OpenGL2.Vertex
#version 400
#define MAX_INSTANCES 256

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 cameramatrix;
uniform mat4 projectioncameramatrix;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;
in vec4 vertex_color;

//Outputs
out vec2 g_texcoords0;
out vec3 g_normal;
out vec3 g_tangent;
out vec3 g_binormal;
out vec3 g_light;
out vec4 g_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;

	g_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);
	gl_Position = g_vertexposition;

	mat3 nmat = mat3(entitymatrix_);
	g_normal = normalize(nmat*vertex_normal);
	g_tangent = normalize(nmat*vertex_tangent);
	g_binormal = normalize(nmat*vertex_binormal);
	g_light = normalize(nmat * vertex_position);
	
	g_texcoords0 = vertex_texcoords0;

}
@OpenGLES2.Vertex

@OpenGLES2.Fragment
#version 400

layout(triangles) in;
layout(triangle_strip, max_vertices=6) out;

//Variables
float line_width = 0.07;
bool smooth_corners = false; //true for simple boxes

//Uniforms
uniform sampler2D texture1;
uniform mat4 projectioncameramatrix;
uniform vec3 cameraposition;
uniform mat4 projectionmatrix;

//Inputs
in vec2 g_texcoords0[];
in vec3 g_normal[];
in vec3 g_tangent[];
in vec3 g_binormal[];
in vec3 g_light[];
in vec4 g_vertexposition[];

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;
out vec4 vertex_color;

void main()
{	
  
  //Original
  for(int i=0; i<3; i++) {
  
	//Position only
    gl_Position = projectioncameramatrix * gl_in[i].gl_Position;

	//passthroughs
	ex_texcoords0 = g_texcoords0[i];
	ex_normal = g_normal[i];
	ex_tangent = g_tangent[i];
	ex_binormal = g_binormal[i];
	ex_vertexposition = g_vertexposition[i];
	vertex_color.a = 0.0;

    EmitVertex();
  }
  
  EndPrimitive();
  
  //Outline instance
  for(int i=0; i<3; i++) {

	//Normal
	vec3 eyevec = normalize(g_vertexposition[i].xyz - cameraposition);
    vec3 outline = vec3(mix(g_normal[i],g_light[i],smooth_corners)*line_width)+eyevec;
	
	//Position and color
    gl_Position = projectioncameramatrix * vec4(gl_in[i].gl_Position.xyz + outline/2.0,1.0);
	vertex_color.a = 1.0;

    EmitVertex();
  }
  
  EndPrimitive();
}
@OpenGL4.Vertex
#version 400
#define MAX_INSTANCES 256

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 cameramatrix;
uniform mat4 projectioncameramatrix;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;
in vec4 vertex_color;

//Outputs
out vec2 g_texcoords0;
out vec3 g_normal;
out vec3 g_tangent;
out vec3 g_binormal;
out vec3 g_light;
out vec4 g_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;

	g_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);
	gl_Position = g_vertexposition;

	mat3 nmat = mat3(entitymatrix_);
	g_normal = normalize(nmat*vertex_normal);
	g_tangent = normalize(nmat*vertex_tangent);
	g_binormal = normalize(nmat*vertex_binormal);
	g_light = normalize(nmat * vertex_position);
	
	g_texcoords0 = vertex_texcoords0;

}
@OpenGL4.Geometry
#version 400

layout(triangles) in;
layout(triangle_strip, max_vertices=6) out;

//Variables
float line_width = 0.07;
bool smooth_corners = false; //true for simple boxes

//Uniforms
uniform sampler2D texture1;
uniform mat4 projectioncameramatrix;
uniform vec3 cameraposition;
uniform mat4 projectionmatrix;

//Inputs
in vec2 g_texcoords0[];
in vec3 g_normal[];
in vec3 g_tangent[];
in vec3 g_binormal[];
in vec3 g_light[];
in vec4 g_vertexposition[];

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;
out vec4 vertex_color;

void main()
{	
  
  //Original
  for(int i=0; i<3; i++) {
  
	//Position only
    gl_Position = projectioncameramatrix * gl_in[i].gl_Position;

	//passthroughs
	ex_texcoords0 = g_texcoords0[i];
	ex_normal = g_normal[i];
	ex_tangent = g_tangent[i];
	ex_binormal = g_binormal[i];
	ex_vertexposition = g_vertexposition[i];
	vertex_color.a = 0.0;

    EmitVertex();
  }
  
  EndPrimitive();
  
  //Outline instance
  for(int i=0; i<3; i++) {

	//Normal
	vec3 eyevec = normalize(g_vertexposition[i].xyz - cameraposition);
    vec3 outline = vec3(mix(g_normal[i],g_light[i],smooth_corners)*line_width)+eyevec;
	
	//Position and color
    gl_Position = projectioncameramatrix * vec4(gl_in[i].gl_Position.xyz + outline/2.0,1.0);
	vertex_color.a = 1.0;

    EmitVertex();
  }
  
  EndPrimitive();
}
@OpenGL4.Fragment
//from https://www.geeks3d.com/20111117/simple-introduction-to-geometry-shader-in-glsl-part-2/

#version 400

//Variables
vec4 outline_color = vec4(1.0,1.0,0.0,1.0);

//Uniforms
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;

//Inputs 
in vec2 ex_texcoords0;
in vec3 ex_normal;
in vec3 ex_tangent;
in vec3 ex_binormal;
in vec4 ex_vertexposition;
in vec4 vertex_color;

out vec4 fragData0;
out vec4 fragData1;
out vec4 fragData2;

void main()
{

	//Diffuse
	vec4 outcolor = texture(texture0,ex_texcoords0);

	//Specular
	vec4 color_specular = texture(texture2,ex_texcoords0);
	float specular = color_specular.r * 0.299 + color_specular.g * 0.587 + color_specular.b * 0.114;

	//Normal
	vec3 normal = ex_normal;
	normal = normalize(texture(texture1,ex_texcoords0).xyz * 2.0 - 1.0);
	normal = ex_tangent * normal.x + ex_binormal * normal.y + ex_normal * normal.z;	
	
	//Establish colors
	if (vertex_color.a > 0.5) {
		outcolor = outline_color;
		color_specular = outline_color;
		normal = vec3(0,1,0);
	}
	else {
		outcolor = outcolor;
		color_specular = vec4(0,0,0,specular);
		normal = normalize(normal);	
	}

	//Output
	fragData0 = outcolor;
	
	//Normals Output
	fragData1 = vec4(normalize(normal)*0.5+0.5,fragData0.a);
	fragData1.a = 1/255.0;

	//Specular output
	fragData2 = vec4(color_specular);
}
